import random
import threading
import traceback
import sys

from proton import ConnectionException
from proton.utils import BlockingConnection
from proton import SSLDomain

from time import sleep
from uuid import uuid4
 
ROUTER_ADDRESS = "proton+amqp://HOSTNAME:%s"
ADDRESS = "pulp.bz1553116"
HEARTBEAT = 5
SLEEP_MIN = 1.0
SLEEP_MAX = 3.0
THREADS = 40
ADDRESSES = 20
 
class ReceiverThread(threading.Thread):
    def __init__(self, port, address=ADDRESS, domain=None):
        super(ReceiverThread, self).__init__()
        self.port = port
        self.address = address
        self.domain = domain
        self.running = True

    def subscribe(self):
	self.recv = self.conn.create_receiver('%s' %(self.address), name=str(uuid4()), dynamic=False, options=None)
 
    def connect(self):
        self.conn = BlockingConnection(ROUTER_ADDRESS % (self.port), ssl_domain=self.domain, heartbeat=HEARTBEAT)
	self.subscribe()
 
    def reconnect(self):
        try:
            self.recv.close()
	except:
	    pass
        try:
    	    self.conn.close()
	except:
            pass
        self.connect()
 
    def run(self):
        self.connect()
        while self.running:
	    try:
	        sleep(random.uniform(SLEEP_MIN,SLEEP_MAX))
	    except KeyboardInterrupt:
                self.running = False
		pass
            try:
		print "(%s): bouncing receiver" % self.port
                self.recv.close()
		self.subscribe()
	    except:
		print "(%s): receiver thread: failed to close receiver" % self.port
		self.reconnect()
		pass
 
    def stop(self):
        self.running = False
 
threads = []
for i in range(THREADS):
  threads.append(ReceiverThread(sys.argv[1], '%s.%s' %(ADDRESS, i%ADDRESSES)))
  threads[i].start()

running = True
while running:
    try:
	sleep(10)
    except KeyboardInterrupt:
        running = False
	pass
#_in = raw_input("Press Enter to exit:")
 
for i in range(THREADS):
    threads[i].stop()
for i in range(THREADS):
    threads[i].join()

