ulimit -c unlimited

killall qdrouterd qpidd
kill -9 $(ps aux | grep mimic | grep python | awk '{ print $2 }')

echo "customizing configs to this hostname.."
# in configs, replace HOSTNAME by real hostname of this machine
for i in mimic_goferd_consumer.py qdrouterd.caps-template.conf qdrouterd-sat.conf; do
	sed -i "s/HOSTNAME/$(hostname -f)/g" $i
done

echo "starting and provisioning qpidd.."
# start qpidd and add queues
qpidd --config ${PWD}/qpidd.conf &
for i in $(seq 0 19); do qpid-config add queue pulp.bz1553116.${i}; done

echo "starting qdrouterd processes.."
# start Satellite's router
qdrouterd -c ${PWD}/qdrouterd-sat.conf &

# generate 10 Capsule's router configs and start the routers
for i in $(seq 0 9); do
	i="0$i"
	sed "s/XX/$i/g" qdrouterd.caps-template.conf > qdrouterd.caps${i}.conf
	qdrouterd -c ${PWD}/qdrouterd.caps${i}.conf &
	sleep 0.5
done

echo
echo "now run this command (ideally from 2 other machines):"
echo
echo "while true; do for j in \$(seq 1 5); do for i in \$(seq 0 9); do python mimic_goferd_consumer.py 560\$i & sleep 0.2; done; done; sleep 20; kill \$(ps aux | grep python | grep mimic | awk '{ print \$2 }'); done"
